# C220726A. 树染色问题

## 题目描述

高钧在校园中漫步时，经过了一棵树。这时，几个同学突然冒出来控制住了他。

这棵树有 $ n $ 个节点，每个节点有黑白两种颜色。为了更好的 alb ，需要将所有节点染成同一种颜色。

为了戏耍高钧，他被告知如果能在最短的时间内把树的所有节点染成同一种颜色，那他就不会被 alb 。

高钧每次操作可以将一个同色连通块染成另一种颜色。他想知道他最少需要几次操作才能把这棵树的所有节点染成同一种颜色。

对于树上的一个点集 $ S $，它是这棵树的同色连通块当且仅当对于所有节点 $ i, j \in S $，节点 $ i $ 的颜色与节点 $ j $ 的颜色相同，且树上 $ i $ 与 $ j $ 之间的简单路径上的所有点都属于 $ S $。

## 输入格式

第一行一个整数 $ n $ 表示树的节点数。

第二行 $ n $ 个整数 $ c_i \in \{0, 1\} $ 表示第 $ i $ 个节点的初始颜色。

接下来 $ n-1 $ 行，每行两个整数 $ a_i, b_i $，表示树上的一条边。

## 输出格式

输出一行一个整数，表示最少的操作次数。

## 样例

### 输入数据 1

```
3
0 1 1
1 2
1 3
```

### 输出数据 1

```
1
```

**样例1说明**：将节点 1 的颜色染成 1 即可。

### 输入数据 2

```
11
0 0 0 1 1 0 1 0 0 1 1
1 2
1 3
2 4
2 5
5 6
5 7
3 8
3 9
3 10
9 11
```

### 输出数据 2

```
2
```

## 数据规模与约定

| 测试点 | $ n $                    | 特殊性质 |
| :----- | :----------------------- | :------- |
| 1      | $ n = 2 $                | 无       |
| 2, 3   | $ n = 7 $                | 无       |
| 4, 5   | $ n \leq 50 $            | 1        |
| 6, 7   | $ n \leq 10^5 $          | 2        |
| 8, 9   | $ n \leq 10^5 $          | 无       |
| 10     | $ n \leq 2 \times 10^5 $ | 无       |

**特殊性质1**：所有节点的颜色在 $\{0, 1\}$ 中随机，$ n $ 不随机，且树的生成方式为第 $ i $（$ i > 1 $）个节点随机向 [1, $ i-1 $] 中的一个节点连一条边。

**特殊性质2**：第 $ i $ 条边连接节点 $ i $ 和 $ i+1 $。

对于 100% 的数据，$ 1 \leq n \leq 2 \times 10^5 $，$ 1 \leq a_i, b_i \leq n $，$ 0 \leq c_i \leq 1 $，保证 $ a_i, b_i $ 构成一棵树。



# C220726B. Multisets

## 题目描述

我们说一个可重集 $ A $ 比可重集 $ B $ 小，当且仅当对于两个可重集中出现次数不同的最小元素 $ x $，元素 $ x $ 在 $ A $ 中出现次数更多。

例如，可重集 $\{1,2,3\}$ 就比可重集 $\{1,3,3,5\}$ 小，类似的，$\{1,1,4,4\}$ 小于 $\{1,1,4\}$。

小 $ C $ 给了你一个长度为 $ n $ 的正整数序列 $ S $。考虑 $ S $ 的所有连续子序列，可以把它们分别看做一个可重集（也就是说，恰好存在着 $\frac{n(n+1)}{2}$ 个可重集）。

小 $ C $ 想知道第 $ k $ 小可重集，想请你帮她找到答案。

## 输入格式

输入共两行。

第一行包含两个整数 $ n $，$ k $。

接下来的一行包含序列 $ S_i $。

## 输出格式

输出共一行。

输出你找到的可重集，**请输出可重集排序后的结果**。

## 样例

### 输入数据 1

```
6 5
1 2 1 3 5 1
```

### 输出数据 1

```
1 1 2
```

### 输入数据 2

```
8 9
6 3 4 4 1 4 5 8
```

### 输出数据 2

```
1 4 4 4 5 8
```

### 输入数据 3

```
50 233
21 7 15 17 43 38 32 12 41 6 31 27 16 25 41 32 22 11 2 30 26 1 9 43 39 18 1 30 4 2 29 40 48 42 1 11 7 45 25 43 14 17 8 16 36 9 29 18 34 17
```

### 输出数据 3

```
1 1 1 2 2 4 7 9 11 11 14 16 17 18 22 25 25 26 27 29 30 30 31 32 39 40 41 42 43 43 45 48
```

## 数据规模与约定

对于 $ 100\% $ 的数据：
- $ 1 \leq S_i \leq n \leq 100000 $
- $ 1 \leq k \leq \frac{n(n+1)}{2} $

子任务划分：
- $ \text{Subtask 1} $（$ 40 $ 分）：$ n \leq 100 $
- $ \text{Subtask 2} $（$ 20 $ 分）：$ n \leq 1000 $
- $ \text{Subtask 3} $（$ 10 $ 分）：$ n \leq 30000 $，$ k \leq 100 $
- $ \text{Subtask 4} $（$ 10 $ 分）：$ n \leq 30000 $，$ S_i \leq 20 $
- $ \text{Subtask 5} $（$ 15 $ 分）：$ n \leq 30000 $
- $ \text{Subtask 6} $（$ 5 $ 分）：无额外约束

提示：保证数据随机生成，但这对你的解题并不是必需的。本题采用子任务形式打包测评，测评时开启 `-02` 优化。

注意：本题暂时没有设置打包测试。

# C220726C. 最优化问题

## 题目描述

在同学们的努力下，高匀感受到了某种快乐。高勺意犹未尽，找来了一个长度为 $ n $ 的序列 $ a_1, a_2, \ldots, a_n $。

她想要删除这个序列中的 $ k $ 个数，然后将剩下的数按下标从小到大排列成一个长度为 $ n-k $ 的序列 $ b_1, b_2, \ldots, b_{n-k} $。

高勺定义她的快乐度为 $ b $ 序列中满足 $ b_i = i $ 的数量，即 $ \sum_{i=1}^{n-k} [b_i = i] $。

高勺想知道她的快乐度的最大值为多少。

## 输入格式

第一行两个整数 $ n $，$ k $，表示序列的长度和删掉数的个数。

第二行 $ n $ 个整数 $ a_i $，表示序列。

## 输出格式

输出一个整数，表示 $ \sum_{i=1}^{n-k} [b_i = i] $ 的最大值。

## 样例

### 输入数据 1

```
8 3
1 1 3 2 4 5 7 5
```

### 输出数据 1

```
4
```

**样例1说明**：可能的序列 $ b $ 为 $[1, 1, 3, 4, 5]$。

### 输入数据 2

```
7 1
1 4 2 5 7 6 4
```

### 输出数据 2

```
2
```

**样例2说明**：可能的序列 $ b $ 为 $[1, 2, 5, 7, 6, 4]$。

## 数据规模与约定

| 测试点  | $ n $                    | $ k $        | 特殊性质 |
| :------ | :----------------------- | :----------- | :------- |
| 1       | $ n \leq 16 $            | $ k \leq n $ | 无       |
| 2, 3, 4 | $ n \leq 5000 $          | $ k \leq n $ | 无       |
| 5       | $ n \leq 10^5 $          | $ k = 1 $    | 无       |
| 6       | $ n \leq 10^5 $          | $ k \leq n $ | 1        |
| 7, 8, 9 | $ n \leq 10^5 $          | $ k \leq n $ | 无       |
| 10      | $ n \leq 5 \times 10^5 $ | $ k \leq n $ | 无       |

**特殊性质1**：对于所有 $ i \in [1, n-1] $，有 $ a_i \leq a_{i+1} $。

对于 100% 的数据，$ n, k \geq 0 $；$ 1 \leq a_i \leq n $。

# #C220726D. 旅行

## 题目描述

Setsuna 和 Kazusa 在制定旅行的计划。

J 国一共有 $n$ 个城市，其中 1 号城市是首都，城市之间用轨道交通连接成了一棵树。具体来说，除了首都之外的所有点，每个点都有和另外一个城市有单向的轨道交通，且从任意城市出发都能沿着单向的轨道交通到达首都。

Setsuna 和 Kazusa 要在学园祭后进行这样一次旅行， 她们两个分别从一个城市出发，并最终在某个城市汇合。在旅行前， 她们给每一个城市定义了一个权值 $a_i$， 假设 Setsuna 和 Kazusa 分别从城市 $x$ 和城市 $y$ 出发， 并最终在城市 $u$（$x, y \neq u$）第一次汇合， 这一次旅行的愉悦度就是 $(\sum_{i \in path(x, u)} a_i) \oplus (\sum_{i \in path(y, u)} a_i)$，其中 $\oplus$ 表示按位异或。

这里定义第一次汇合为，$x$ 和 $y$ 到 $u$ 的路径上，除了 $u$ 以外不存在其它被两个人都经过的城市。

现在 Setsuna 和 Kazusa 想知道， 对于所有城市 $i$ ， 如果最终要在城市 $i$ 第一次汇合，能得到的最大的旅行愉悦度是多少。如果城市 $i$ 无法成为一次旅行第一次汇合的节点，则愉悦度为 $-1$ 。

## 输入格式

第一行一个数 $n$ 。

接下来一行 $n-1$ 个数，第 $i$ 个数表示 $i+1$ 号城市轨道交通连向的城市。

接下来一行 $n$ 个数，第 $i$ 个数为 $a_i$ 。

## 输出格式

输出一行 $n$ 个数，第 $i$ 个数表示如果最终要在节点 $i$ 汇合能得到的最大的旅行愉悦度。

## 样例

### 输入数据 1

```
7
1 1 2 2 3 3
1 1 4 5 1 4 9
```

### 输出数据 1

```
14 4 5 -1 -1 -1 -1
```

### 样例1说明

- 对于 1 号城市，选择城市 4，6 愉悦度为 $7 \oplus 9 = 14$。
- 对于 2 号城市，选择城市 4，5 愉悦度为 $6 \oplus 2 = 4$。
- 对于 3 号城市，选择城市 6，7 愉悦度为 $8 \oplus 13 = 5$。
- 对于 4，5，6，7 号城市，无法成为一次旅行第一次汇合的节点，愉悦度为 $-1$。

## 数据规模与约定

- 对于编号为 1 的测试点，$n \leq 100$。
- 对于编号为 2 的测试点，$n \leq 2000$。
- 对于编号为 3 的测试点，保证所有城市的单向链接都是 1 号城市。
- 对于编号为 4 的测试点，保证除了1号城市外每个城市至多被一个城市单向链接。
- 对于编号为 5 的测试点，保证树为一棵完全二叉树。
- 对于编号为 6 的测试点，保证树的形态随机。
- 对于编号为 7 的测试点，$n \leq 50000$。
- 对于全部的测试点，$n \leq 100000$；$0 \leq a_i \leq 200$；保证 $a_i$ 随机。